<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="20131001" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:C_Cpp="http://www.eclipse.org/papyrus/C_Cpp/1" xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore" xmlns:robotics.components="http://www.eclipse.org/papyrus/robotics/components/1" xmlns:robotics.functions="http://www.eclipse.org/papyrus/robotics/functions/1" xmlns:robotics.generics="http://www.eclipse.org/papyrus/robotics/generics/1" xmlns:robotics.parameters="http://www.eclipse.org/papyrus/robotics/parameters/1" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xsi:schemaLocation="http://www.eclipse.org/papyrus/robotics/components/1 http://www.eclipse.org/papyrus/robotics/1#//components http://www.eclipse.org/papyrus/robotics/functions/1 http://www.eclipse.org/papyrus/robotics/1#//functions http://www.eclipse.org/papyrus/robotics/generics/1 http://www.eclipse.org/papyrus/robotics/1#//generics http://www.eclipse.org/papyrus/robotics/parameters/1 http://www.eclipse.org/papyrus/robotics/1#//parameters">
  <uml:Model xmi:id="_6nSQsEfEEeiwO_ETU0BG9A" name="intermediate">
    <ownedComment xmi:type="uml:Comment" xmi:id="_ETCcQF0bEeqenIMm5aFGvw" annotatedElement="_6nSQsEfEEeiwO_ETU0BG9A">
      <body>This is an intermediate server that forwards incoming requests to the &quot;real&quot; server. The handler code receives a request from the client node, creates an asynchronous request to the server node and then waits for a result of the obtained future.
The &quot;wait&quot; call on the future blocks the handler threat. The response of the server is also treated by a handler callback. Thus, the call would deadlock, if both handlers would be part of the same callback group. Therefore, both ports are attached to different activities, resulting in two different callback groups during code generation.</body>
    </ownedComment>
    <packageImport xmi:type="uml:PackageImport" xmi:id="_lwxc0ExOEei_Sui04GqxlQ">
      <importedPackage xmi:type="uml:Model" href="pathmap://ROBOTICS_LIBRARIES/robotics.library.uml#_LaOOAJcvEeeV0-Lu2yLOjA"/>
    </packageImport>
    <packageImport xmi:type="uml:PackageImport" xmi:id="_vPI0sExOEei_Sui04GqxlQ">
      <importedPackage xmi:type="uml:Model" href="pathmap://UML_LIBRARIES/UMLPrimitiveTypes.library.uml#_0"/>
    </packageImport>
    <packageImport xmi:type="uml:PackageImport" xmi:id="_VwyNkPV1EemSEqXywHKEEA">
      <importedPackage xmi:type="uml:Model" href="pathmap://ROS2_TESTMODELS/simple_msgs/models/services/simple_msgs.servicedef.uml#_6nSQsEfEEeiwO_ETU0BG9A"/>
    </packageImport>
    <packagedElement xmi:type="uml:Class" xmi:id="_-9MoUEiFEeiAtInRNnLmIQ" name="IntermediateServer">
      <ownedAttribute xmi:type="uml:Property" xmi:id="_DPbI0HX0EeirHb2XH36K_A" name="activity2" type="_DNyKEHX0EeirHb2XH36K_A"/>
      <ownedAttribute xmi:type="uml:Port" xmi:id="_6SlXMHq1EeikT4nAmbXssQ" name="useAdd" type="_ZYcQwPV1EemSEqXywHKEEA" aggregation="composite"/>
      <ownedAttribute xmi:type="uml:Port" xmi:id="_Pi2HgL2oEe2La-1oivd53w" name="addServiceDef" type="_Q-CTIL2oEe2La-1oivd53w" aggregation="composite"/>
      <ownedAttribute xmi:type="uml:Property" xmi:id="_rs0_IL9XEe2La-1oivd53w" name="activity01" type="_rsnjwL9XEe2La-1oivd53w"/>
      <ownedConnector xmi:type="uml:Connector" xmi:id="_OrKG4KgrEeqREZyOpEdqSw" name="Connects6">
        <end xmi:type="uml:ConnectorEnd" xmi:id="_OrUe8KgrEeqREZyOpEdqSw" role="_6SlXMHq1EeikT4nAmbXssQ"/>
        <end xmi:type="uml:ConnectorEnd" xmi:id="_OrVGAKgrEeqREZyOpEdqSw" partWithPort="_DPbI0HX0EeirHb2XH36K_A" role="_Fv2rwHq2EeikT4nAmbXssQ"/>
      </ownedConnector>
      <ownedConnector xmi:type="uml:Connector" xmi:id="_zGJ9IL9XEe2La-1oivd53w" name="Connects11">
        <end xmi:type="uml:ConnectorEnd" xmi:id="_zGNAcL9XEe2La-1oivd53w" role="_Pi2HgL2oEe2La-1oivd53w"/>
        <end xmi:type="uml:ConnectorEnd" xmi:id="_zGNAcb9XEe2La-1oivd53w" partWithPort="_rs0_IL9XEe2La-1oivd53w" role="_vpV4AL9XEe2La-1oivd53w"/>
      </ownedConnector>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_kiyUIEiHEeiAtInRNnLmIQ" name="ParameterSet"/>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_DNyKEHX0EeirHb2XH36K_A" name="A2">
        <generalization xmi:type="uml:Generalization" xmi:id="_DN1NYHX0EeirHb2XH36K_A">
          <general xmi:type="uml:Class" href="pathmap://ROBOTICS_LIBRARIES/robotics.library.uml#_dFzyYPn9Eee8c8wpObBu7w"/>
        </generalization>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_zS1mQIQMEeqvFNZCXiiVuA" name=""/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_dI62YHX0EeirHb2XH36K_A" name="activate" visibility="public"/>
        <ownedAttribute xmi:type="uml:Port" xmi:id="_Fv2rwHq2EeikT4nAmbXssQ" name="addCaller" aggregation="composite"/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_DLj3oIGKEeqBWvhpPyY2CQ" name="" type="_DLeYEIGKEeqBWvhpPyY2CQ"/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_g4hSkIO1EeqvFNZCXiiVuA" name=""/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_X1AyAb2oEe2La-1oivd53w" name=""/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_TABhcb9HEe2La-1oivd53w" name=""/>
      </nestedClassifier>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_ZYcQwPV1EemSEqXywHKEEA"/>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_Q-CTIL2oEe2La-1oivd53w">
        <interfaceRealization xmi:type="uml:InterfaceRealization" xmi:id="_Qig9ML9HEe2La-1oivd53w" client="_Q-CTIL2oEe2La-1oivd53w">
          <supplier xmi:type="uml:Interface" href="pathmap://ROS2_TESTMODELS/simple_msgs/models/services/simple_msgs.servicedef.uml#_aTuOIHoWEeif1855zzC59A"/>
          <contract xmi:type="uml:Interface" href="pathmap://ROS2_TESTMODELS/simple_msgs/models/services/simple_msgs.servicedef.uml#_aTuOIHoWEeif1855zzC59A"/>
        </interfaceRealization>
      </nestedClassifier>
      <nestedClassifier xmi:type="uml:Class" xmi:id="_rsnjwL9XEe2La-1oivd53w" name="A1">
        <ownedAttribute xmi:type="uml:Port" xmi:id="_vpV4AL9XEe2La-1oivd53w" name="addHandler" aggregation="composite"/>
        <ownedAttribute xmi:type="uml:Property" xmi:id="_zGR48b9XEe2La-1oivd53w" name="" type="_zGQDwL9XEe2La-1oivd53w"/>
      </nestedClassifier>
    </packagedElement>
    <packagedElement xmi:type="uml:Usage" xmi:id="_u0gz8PV5EemIj9SnfMX-0g" client="_ZYcQwPV1EemSEqXywHKEEA">
      <supplier xmi:type="uml:Interface" href="pathmap://ROS2_TESTMODELS/simple_msgs/models/services/simple_msgs.servicedef.uml#_aTuOIHoWEeif1855zzC59A"/>
    </packagedElement>
    <packagedElement xmi:type="uml:OpaqueBehavior" xmi:id="_DLeYEIGKEeqBWvhpPyY2CQ" name="fResultCallback" language="" body=""/>
    <packagedElement xmi:type="uml:OpaqueBehavior" xmi:id="_zGQDwL9XEe2La-1oivd53w" name="addServiceDef_handler" language="" body=""/>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_6voUYEfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_6vqJkEfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/bpc/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_BPC_PROFILES/bpc.profile.uml#__9qqMJZ1Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7CwrwEfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7CxS0EfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#__9qqMJZ1Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7Cyg8EfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7Cyg8UfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//components"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_EZ1TgJZ2Eeeq1f8hGgKVzA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7Cyg8kfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7Cyg80fEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//commpattern"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_8Z6x8Je6EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7CzIAkfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7CzvEEfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//deployment"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_tu6OsJe9EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7CzvEUfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7CzvEkfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//services"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_SlbOAJe_EeeiCOWsEr9OuA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7C0WIEfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7C0WIUfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//commobject"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_bz5AcPCaEeee6ab5J_C5Dg"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7C0WIkfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7C09MEfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//functions"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_SV7GwC6LEei0V9-WLHIyvg"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_7C09MUfEEeiwO_ETU0BG9A">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_7C1kQEfEEeiwO_ETU0BG9A" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//parameters"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_-pU5oDmpEei--ZsfKWaFtw"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_vBSogEfFEeiuVfmPqBuUBA">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_vBVEwEfFEeiuVfmPqBuUBA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/MARTE/1#//MARTE_Foundations/NFPs"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://Papyrus_PROFILES/MARTE.profile.uml#_U_GAoAPMEdyuUt-4qHuVvQ"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_vBXhAEfFEeiuVfmPqBuUBA">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_vBXhAUfFEeiuVfmPqBuUBA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/MARTE/1#//MARTE_Annexes/VSL/DataTypes"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://Papyrus_PROFILES/MARTE.profile.uml#_9FdqwA-MEdyLh7muGbCqMw"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_QpoCUEfMEeiuVfmPqBuUBA">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_QpopYEfMEeiuVfmPqBuUBA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="pathmap://PAPYRUS_ACTIONLANGUAGE_PROFILE/ActionLanguage-Profile.profile.uml#_Kv8EIKFXEeS_KNX0nfvIVQ"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://PAPYRUS_ACTIONLANGUAGE_PROFILE/ActionLanguage-Profile.profile.uml#ActionLanguage"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_I4cKUEoDEeie-dKbx_4wnA">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_I442QEoDEeie-dKbx_4wnA" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/robotics/1#//generics"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://ROBOTICS_PROFILES/robotics.profile.uml#_eFhjMEnvEeien6eLHpkAxA"/>
    </profileApplication>
    <profileApplication xmi:type="uml:ProfileApplication" xmi:id="_eP0y4KcHEemKm7jDzAkd-g">
      <eAnnotations xmi:type="ecore:EAnnotation" xmi:id="_eP5EUKcHEemKm7jDzAkd-g" source="http://www.eclipse.org/uml2/2.0.0/UML">
        <references xmi:type="ecore:EPackage" href="http://www.eclipse.org/papyrus/C_Cpp/1#/"/>
      </eAnnotations>
      <appliedProfile xmi:type="uml:Profile" href="pathmap://PapyrusC_Cpp_PROFILES/C_Cpp.profile.uml#_j9REUByGEduN1bTiWJ0lyw"/>
    </profileApplication>
  </uml:Model>
  <robotics.components:ComponentDefinition xmi:id="_-9VLMEiFEeiAtInRNnLmIQ" base_Class="_-9MoUEiFEeiAtInRNnLmIQ"/>
  <robotics.parameters:Parameter xmi:id="_ki1XcEiHEeiAtInRNnLmIQ" base_Class="_kiyUIEiHEeiAtInRNnLmIQ"/>
  <robotics.components:Activity xmi:id="_DN4QsHX0EeirHb2XH36K_A" base_Class="_DNyKEHX0EeirHb2XH36K_A"/>
  <robotics.components:ActivityInstance xmi:id="_DPfaQHX0EeirHb2XH36K_A" base_Property="_DPbI0HX0EeirHb2XH36K_A"/>
  <C_Cpp:Include xmi:id="_rrFA0Hh8Eei2lO6rEWqUCQ" preBody="#include &lt;iostream>&#xA;using namespace std;" base_class="_-9MoUEiFEeiAtInRNnLmIQ" base_Classifier="_-9MoUEiFEeiAtInRNnLmIQ"/>
  <robotics.components:ComponentPort xmi:id="_6SoagHq1EeikT4nAmbXssQ" base_Port="_6SlXMHq1EeikT4nAmbXssQ"/>
  <robotics.components:ActivityPort xmi:id="_Fv69MHq2EeikT4nAmbXssQ" base_Port="_Fv2rwHq2EeikT4nAmbXssQ"/>
  <robotics.components:ComponentDefinitionModel xmi:id="_3qoH0NAQEemsvtLt7dgtCQ" authorship="ansgar.radermacher@cea.fr Ansgar" provenance="info-list@cea.fr CEA LIST" base_Package="_6nSQsEfEEeiwO_ETU0BG9A"/>
  <robotics.components:ComponentService xmi:id="_ZYkMkPV1EemSEqXywHKEEA" base_Class="_ZYcQwPV1EemSEqXywHKEEA"/>
  <robotics.functions:Function xmi:id="_DLgNQIGKEeqBWvhpPyY2CQ" base_Class="_DLeYEIGKEeqBWvhpPyY2CQ" activityPort="_Fv69MHq2EeikT4nAmbXssQ"/>
  <robotics.generics:Connects xmi:id="_OrVtEKgrEeqREZyOpEdqSw" base_Connector="_OrKG4KgrEeqREZyOpEdqSw"/>
  <robotics.components:ComponentService xmi:id="_Q-F9gL2oEe2La-1oivd53w" base_Class="_Q-CTIL2oEe2La-1oivd53w"/>
  <robotics.components:ComponentPort xmi:id="_Q-ZfgL2oEe2La-1oivd53w" base_Port="_Pi2HgL2oEe2La-1oivd53w"/>
  <robotics.components:ActivityInstance xmi:id="_rs7FwL9XEe2La-1oivd53w" base_Property="_rs0_IL9XEe2La-1oivd53w"/>
  <robotics.components:Activity xmi:id="_rs-JEL9XEe2La-1oivd53w" base_Class="_rsnjwL9XEe2La-1oivd53w"/>
  <robotics.components:ActivityPort xmi:id="_vpZiYL9XEe2La-1oivd53w" base_Port="_vpV4AL9XEe2La-1oivd53w"/>
  <robotics.generics:Connects xmi:id="_zGNAcr9XEe2La-1oivd53w" base_Connector="_zGJ9IL9XEe2La-1oivd53w"/>
  <robotics.functions:Function xmi:id="_zGR48L9XEe2La-1oivd53w" base_Class="_zGQDwL9XEe2La-1oivd53w" activityPort="_vpZiYL9XEe2La-1oivd53w"/>
</xmi:XMI>
